scala.collection.generic

# AtomicIndexFlag

#### trait AtomicIndexFlag extends Signalling

A mixin trait that implements index flag behaviour using atomic integers. The `setIndex` operation is wait-free, while conditional set operations `setIndexIfGreater` and `setIndexIfLesser` are lock-free and support only monotonic changes.

Source
  Signalling.scala

Linear Supertypes
Signalling, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. AtomicIndexFlag
2. Signalling
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def abort(): Unit

   Sends an abort signal to other workers.

   Sends an abort signal to other workers.

   Abort flag being true means that a worker can abort and produce whatever result, since its result will not affect the final result of computation. An example of operations using this are `find`, `forall` and `exists` methods.

   Definition Classes
     Signalling

2. #### abstract def isAborted: Boolean

   Checks whether an abort signal has been issued.

   Checks whether an abort signal has been issued.

   Abort flag being true means that a worker can abort and produce whatever result, since its result will not affect the final result of computation. An example of operations using this are `find`, `forall` and `exists` methods.

   returns

     the state of the abort

   Definition Classes
     Signalling

3. #### abstract def tag: Int

   A read only tag specific to the signalling object.

   A read only tag specific to the signalling object. It is used to give specific workers information on the part of the collection being operated on.

   Definition Classes
     Signalling

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

8. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

9. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. See equals in Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

10. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

11. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

12. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

13. #### def indexFlag: Int

    Returns the value of the index flag.

    Returns the value of the index flag.

    The index flag holds an integer which carries some operation-specific meaning. For instance, `takeWhile` operation sets the index flag to the position of the element where the predicate fails. Other workers may check this index against the indices they are working on and return if this index is smaller than their index. Examples of operations using this are `takeWhile`, `dropWhile`, `span` and `indexOf`.

    returns

      the value of the index flag

    Definition Classes
      AtomicIndexFlag → Signalling

14. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

15. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

16. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

17. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

18. #### def setIndexFlag(f: Int): Unit

    Sets the value of the index flag.

    Sets the value of the index flag.

    The index flag holds an integer which carries some operation-specific meaning. For instance, `takeWhile` operation sets the index flag to the position of the element where the predicate fails. Other workers may check this index against the indices they are working on and return if this index is smaller than their index. Examples of operations using this are `takeWhile`, `dropWhile`, `span` and `indexOf`.

    f

      the value to which the index flag is set.

    Definition Classes
      AtomicIndexFlag → Signalling

19. #### def setIndexFlagIfGreater(f: Int): Unit

    Sets the value of the index flag if argument is greater than current value.

    Sets the value of the index flag if argument is greater than current value. This method does this atomically.

    The index flag holds an integer which carries some operation-specific meaning. For instance, `takeWhile` operation sets the index flag to the position of the element where the predicate fails. Other workers may check this index against the indices they are working on and return if this index is smaller than their index. Examples of operations using this are `takeWhile`, `dropWhile`, `span` and `indexOf`.

    f

      the value to which the index flag is set

    Definition Classes
      AtomicIndexFlag → Signalling

20. #### def setIndexFlagIfLesser(f: Int): Unit

    Sets the value of the index flag if argument is lesser than current value.

    Sets the value of the index flag if argument is lesser than current value. This method does this atomically.

    The index flag holds an integer which carries some operation-specific meaning. For instance, `takeWhile` operation sets the index flag to the position of the element where the predicate fails. Other workers may check this index against the indices they are working on and return if this index is smaller than their index. Examples of operations using this are `takeWhile`, `dropWhile`, `span` and `indexOf`.

    f

      the value to which the index flag is set

    Definition Classes
      AtomicIndexFlag → Signalling

21. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

22. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

23. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

24. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

25. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from Signalling

### Inherited from AnyRef

### Inherited from Any